CC = iccavr
CFLAGS =  -e -D__ICC_VERSION="7.13A" -DATMEGA -D_EE_EXTIO -DATMega168  -l -g -Mavr_enhanced 
ASFLAGS = $(CFLAGS)  -Wa-g
LFLAGS =  -g -e:0x4000 -ucrtatmega.o -bfunc_lit:0x68.0x4000 -dram_end:0x4ff -bdata:0x100.0x4ff -dhwstk_size:30 -beeprom:0.512 -fihx_coff -S2
FILES = 7SegmentDisplay.o LED_Display.o TWI_slave.o Timer.o Serial.o Board.o RingBuffer.o 

7SEGMENTDISPLAY:	$(FILES)
	$(CC) -o 7SEGMENTDISPLAY $(LFLAGS) @7SEGMENTDISPLAY.lk   -lcatmega
7SegmentDisplay.o: C:\iccv7avr\include\stdio.h C:\iccv7avr\include\stdarg.h C:\iccv7avr\include\_const.h C:\iccv7avr\include\iom168v.h C:\iccv7avr\include\macros.h C:\iccv7avr\include\string.h C:\iccv7avr\include\stdlib.h C:\iccv7avr\include\limits.h C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\Board.h C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\Timer.h C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\Serial.h C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\TWI_slave.h C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\LED_Display.h
7SegmentDisplay.o:	C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\7SegmentDisplay.c
	$(CC) -c $(CFLAGS) C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\7SegmentDisplay.c
LED_Display.o: C:\iccv7avr\include\iom168v.h C:\iccv7avr\include\stdlib.h C:\iccv7avr\include\_const.h C:\iccv7avr\include\limits.h C:\iccv7avr\include\string.h C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\LED_Display.h
LED_Display.o:	C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\LED_Display.c
	$(CC) -c $(CFLAGS) C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\LED_Display.c
TWI_slave.o: C:\iccv7avr\include\stdio.h C:\iccv7avr\include\stdarg.h C:\iccv7avr\include\_const.h C:\iccv7avr\include\iom168v.h C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\TWI_slave.h C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\Board.h C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\Serial.h C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\RingBuffer.h C:\iccv7avr\include\macros.h
TWI_slave.o:	C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\TWI_slave.c
	$(CC) -c $(CFLAGS) C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\TWI_slave.c
Timer.o: C:\iccv7avr\include\iom168v.h C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\Timer.h C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\LED_Display.h
Timer.o:	C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\Timer.c
	$(CC) -c $(CFLAGS) C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\Timer.c
Serial.o: C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\Board.h C:\iccv7avr\include\iom168v.h C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\Serial.h
Serial.o:	C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\Serial.c
	$(CC) -c $(CFLAGS) C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\Serial.c
Board.o: C:\iccv7avr\include\iom168v.h C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\Board.h
Board.o:	C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\Board.c
	$(CC) -c $(CFLAGS) C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\Board.c
RingBuffer.o: C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\RingBuffer.h C:\iccv7avr\include\iom168v.h C:\iccv7avr\include\macros.h
RingBuffer.o:	C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\RingBuffer.c
	$(CC) -c $(CFLAGS) C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\RingBuffer.c
