#include <iom168v.h>
#include "Board.h"

unsigned char currentButtonValue;

void Buttons_Init(void)
{
 	 DDRD &= ~((1<<SW2) | (1<<SW3));//Ensure the button pins are inputs
}

unsigned char buttonState(unsigned char sw)
{
 		 unsigned char value = 0;
		 
		 if (!(PIND&(1<<sw)))
		 {
		  	value = 1;
		 }
		 return value;
}

void updateButtons(void)
{
 	 currentButtonValue = ( ~(PIND & ( (1<<SW2) | (1<<SW3) ) ) )&( (1<<SW2) | (1<<SW3) );
}