	.module LED_Display.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\LED_Display.c
	.area lit(rom, con, rel)
_LED_B_CONTROL::
	.byte 0,0
	.byte 0,0
	.byte 0,0
	.byte 32,16
	.dbsym e LED_B_CONTROL _LED_B_CONTROL A[8:8]kc
_LED_D_CONTROL::
	.byte 4,8
	.byte 16,32
	.byte 64,128
	.byte 0,0
	.dbsym e LED_D_CONTROL _LED_D_CONTROL A[8:8]kc
_numbers::
	.byte 'P,249
	.byte 196,224
	.byte 'i,'b
	.byte 'B,248
	.byte 64,'h
	.byte 'H,'C
	.byte 'V,193
	.byte 'F,'N
	.dbsym e numbers _numbers A[16:16]kc
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\LED_Display.c
	.dbfunc e Display_Float _Display_Float fV
;           text -> y+4
;        outstrg -> R12,R13
;              j -> R22,R23
;              i -> y+2
;  decimalAmount -> R10,R11
;           line -> R20,R21
;         fvalue -> y+22
	.even
_Display_Float::
	xcall push_arg4
	xcall push_xgsetF0FC
	sbiw R28,12
	ldd R20,y+26
	ldd R21,y+27
	ldd R10,y+28
	ldd R11,y+29
	.dbline -1
	.dbline 26
; #include <iom168v.h>
; #include <stdlib.h>
; #include <string.h>
; #include "LED_Display.h"
; 
; #define LED_B_CONTROL_MASK ~((1<<4)|(1<<5))
; #define LED_D_CONTROL_MASK ~((1<<2) | (1<<3) | (1<<4) | (1<<5) | (1<<6) | (1<<7))
; 
; #define LED_B_DATA_MASK ((1<<0) | (1<<1) | (1<<2) | (1<<3))
; #define LED_C_DATA_MASK ((1<<0) | (1<<1) | (1<<2) | (1<<3))
; 	 
; //The arrays below contain the port control lines for each of the 7 segment displays 
; const char LED_B_CONTROL[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x10};
; const char LED_D_CONTROL[] = {0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 0x00, 0x00};
; //0-F
; const unsigned char numbers[] = {0x50,0xF9,0xC4,0xE0,0x69,0x62,0x42,0xF8,0x40,0x68,0x48,0x43,0x56,0xC1,0x46,0x4E};
; 
; //
; unsigned char display[LINES][WIDTH];
; 
; /*
;  *Call this function to display an float on the 7segment display
;  *decimalAmount will set how many decimal places will be displayed
;  */
; void Display_Float(float fvalue,short line, short decimalAmount)
; {
	.dbline 29
; 	char *outstrg;
; 	unsigned char text[WIDTH];
; 	int i,j=0;
	clr R22
	clr R23
	.dbline 33
; 
; 	
; 	//If we try to write to an invalid line number
; 	if (line >= LINES)
	cpi R20,1
	ldi R30,0
	cpc R21,R30
	brlt L2
X0:
	.dbline 34
; 	{
	.dbline 35
; 	  	return;
	xjmp L1
L2:
	.dbline 38
; 	}
; 	 
; 	if(fvalue>0) fvalue += 0.00001;
	movw R24,R28
	adiw R24,22
	ldi R16,<L6
	ldi R17,>L6
	xcall lpm32
	st -y,R25
	st -y,R24
	xcall fpcmp1
	brge L4
X1:
	.dbline 38
	ldd R2,y+22
	ldd R3,y+23
	ldd R4,y+24
	ldd R5,y+25
	ldi R16,<L7
	ldi R17,>L7
	xcall lpm32
	st -y,R19
	st -y,R18
	st -y,R17
	st -y,R16
	movw R16,R2
	movw R18,R4
	xcall fpadd2
	std y+22,R16
	std y+23,R17
	std y+24,R18
	std y+25,R19
L4:
	.dbline 39
; 	if(fvalue<0) fvalue -= 0.00001;
	ldd R2,y+22
	ldd R3,y+23
	ldd R4,y+24
	ldd R5,y+25
	ldi R16,<L6
	ldi R17,>L6
	xcall lpm32
	st -y,R19
	st -y,R18
	st -y,R17
	st -y,R16
	movw R16,R2
	movw R18,R4
	xcall fpcmp2
	brge L8
X2:
	.dbline 39
	ldd R2,y+22
	ldd R3,y+23
	ldd R4,y+24
	ldd R5,y+25
	ldi R16,<L7
	ldi R17,>L7
	xcall lpm32
	st -y,R19
	st -y,R18
	st -y,R17
	st -y,R16
	movw R16,R2
	movw R18,R4
	xcall fpsub2
	std y+22,R16
	std y+23,R17
	std y+24,R18
	std y+25,R19
L8:
	.dbline 41
; 	
; 	outstrg = ftoa(fvalue,&i);
	movw R24,R28
	adiw R24,2
	std y+1,R25
	std y+0,R24
	ldd R16,y+22
	ldd R17,y+23
	ldd R18,y+24
	ldd R19,y+25
	xcall _ftoa
	movw R12,R16
	.dbline 43
; 	
; 	for(i=0; i < WIDTH; i++)
	clr R2
	clr R3
	std y+3,R3
	std y+2,R2
L10:
	.dbline 44
; 	{
	.dbline 45
; 	 	if( j< strlen(outstrg))
	movw R16,R12
	xcall _strlen
	cp R22,R16
	cpc R23,R17
	brlo X9
	xjmp L14
X9:
X3:
	.dbline 46
; 		{
	.dbline 47
; 	 	 		if(outstrg[j]=='.')
	movw R30,R22
	add R30,R12
	adc R31,R13
	ldd R24,z+0
	cpi R24,46
	brne L16
X4:
	.dbline 48
; 				{
	.dbline 49
; 				 	 i--;//we are working on the last digit
	ldd R24,y+2
	ldd R25,y+3
	sbiw R24,1
	std y+3,R25
	std y+2,R24
	.dbline 50
; 		    	 	 text[i] = text[i]&DECIMAL_POINT;
	movw R24,R28
	adiw R24,4
	ldd R14,y+2
	ldd R15,y+3
	add R14,R24
	adc R15,R25
	movw R30,R14
	ldd R24,z+0
	andi R24,191
	std z+0,R24
	.dbline 52
; 					 //how far we want to shift it
; 					 decimalAmount = WIDTH - (decimalAmount+i+1);
	ldd R2,y+2
	ldd R3,y+3
	movw R24,R10
	add R24,R2
	adc R25,R3
	adiw R24,1
	ldi R30,8
	ldi R31,0
	movw R10,R30
	sub R10,R24
	sbc R11,R25
	.dbline 53
; 				}
	xjmp L17
L16:
	.dbline 54
; 				else if(outstrg[j]=='-')
	movw R30,R22
	add R30,R12
	adc R31,R13
	ldd R24,z+0
	cpi R24,45
	brne L18
X5:
	.dbline 55
; 				{
	.dbline 56
; 		    	 	 text[i] = MINUS;
	movw R24,R28
	adiw R24,4
	ldd R30,y+2
	ldd R31,y+3
	add R30,R24
	adc R31,R25
	ldi R24,239
	std z+0,R24
	.dbline 57
; 				}
	xjmp L19
L18:
	.dbline 59
; 				else
; 				{
	.dbline 60
; 		 		 	text[i] = numbers[outstrg[j]-'0'];
	movw R30,R22
	add R30,R12
	adc R31,R13
	ldd R30,z+0
	clr R31
	ldi R24,<_numbers-48
	ldi R25,>_numbers-48
	add R30,R24
	adc R31,R25
	lpm R2,Z
	movw R24,R28
	adiw R24,4
	ldd R30,y+2
	ldd R31,y+3
	add R30,R24
	adc R31,R25
	std z+0,R2
	.dbline 63
; 					
; 			
; 				}
L19:
L17:
	.dbline 64
; 				j++;
	subi R22,255  ; offset = 1
	sbci R23,255
	.dbline 65
; 		}
	xjmp L15
L14:
	.dbline 67
; 		else
; 		{
	.dbline 68
; 		 	text[i] = numbers[0];//fill in zeros
	movw R24,R28
	adiw R24,4
	ldd R30,y+2
	ldd R31,y+3
	add R30,R24
	adc R31,R25
	ldi R26,<_numbers
	ldi R27,>_numbers
	st -y,R31
	st -y,R30
	movw R30,R26
	lpm R2,Z
	ld R30,y+
	ld R31,y+
	std z+0,R2
	.dbline 69
; 		}
L15:
	.dbline 70
; 	}
L11:
	.dbline 43
	ldd R24,y+2
	ldd R25,y+3
	adiw R24,1
	std y+3,R25
	std y+2,R24
	.dbline 43
	cpi R24,8
	ldi R30,0
	cpc R25,R30
	brge X10
	xjmp L10
X10:
X6:
	.dbline 73
; 	
; 	
; 	for(i = WIDTH-1; i >= 0 ; i--)
	ldi R24,7
	ldi R25,0
	std y+3,R25
	std y+2,R24
L21:
	.dbline 74
; 	{
	.dbline 75
; 			if(i-decimalAmount>=0)
	ldd R24,y+2
	ldd R25,y+3
	sub R24,R10
	sbc R25,R11
	cpi R24,0
	ldi R30,0
	cpc R25,R30
	brlt L25
X7:
	.dbline 76
; 			{
	.dbline 77
; 					display[line][i] = text[i-decimalAmount];
	ldd R30,y+2
	ldd R31,y+3
	sub R30,R10
	sbc R31,R11
	movw R24,R28
	adiw R24,4
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldi R24,<_display
	ldi R25,>_display
	movw R4,R20
	lsl R4
	rol R5
	lsl R4
	rol R5
	lsl R4
	rol R5
	add R4,R24
	adc R5,R25
	ldd R30,y+2
	ldd R31,y+3
	add R30,R4
	adc R31,R5
	std z+0,R2
	.dbline 78
; 			}
	xjmp L26
L25:
	.dbline 80
; 			else
; 			{
	.dbline 81
; 					display[line][i] = BLANK_SPACE;
	ldi R24,<_display
	ldi R25,>_display
	movw R2,R20
	lsl R2
	rol R3
	lsl R2
	rol R3
	lsl R2
	rol R3
	add R2,R24
	adc R3,R25
	ldd R30,y+2
	ldd R31,y+3
	add R30,R2
	adc R31,R3
	ldi R24,255
	std z+0,R24
	.dbline 82
; 			}
L26:
	.dbline 83
; 	}
L22:
	.dbline 73
	ldd R24,y+2
	ldd R25,y+3
	sbiw R24,1
	std y+3,R25
	std y+2,R24
	.dbline 73
	cpi R24,0
	ldi R30,0
	cpc R25,R30
	brlt X11
	xjmp L21
X11:
X8:
	.dbline -2
L1:
	.dbline 0 ; func end
	adiw R28,12
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
	.dbsym l text 4 A[8:8]c
	.dbsym r outstrg 12 pc
	.dbsym r j 22 I
	.dbsym l i 2 I
	.dbsym r decimalAmount 10 S
	.dbsym r line 20 S
	.dbsym l fvalue 22 D
	.dbend
	.dbfunc e Display_Int _Display_Int fV
;            end -> R10,R11
;           temp -> R14
;          start -> R12,R13
;           text -> y+0
;          count -> R20,R21
;           base -> R14,R15
;           line -> R22,R23
;          value -> y+18
	.even
_Display_Int::
	xcall push_arg4
	xcall push_xgsetF0FC
	movw R22,R18
	sbiw R28,8
	ldd R14,y+22
	ldd R15,y+23
	.dbline -1
	.dbline 90
; }
; 
; /*
;  *Call this function to display an integer on the 7segment display
;  */
; void Display_Int(int value, short line, short base)
; {
	.dbline 93
;  	 unsigned char text[WIDTH];
;  
;  	 short start=0, count = 0,end;
	clr R12
	clr R13
	.dbline 93
	clr R20
	clr R21
	.dbline 97
; 	 unsigned char temp;
; 	 
; 	 //if we try to write to a line that does not exist, do nothing
; 	 if (line >= LINES)
	cpi R22,1
	ldi R30,0
	cpc R23,R30
	brlt L28
X12:
	.dbline 98
; 	 {
	.dbline 99
; 	  	return;
	xjmp L27
L28:
	.dbline 102
; 	 }
; 	 
; 	 if (base == DEC)
	movw R24,R14
	cpi R24,10
	ldi R30,0
	cpc R25,R30
	brne L30
X13:
	.dbline 103
; 	 {
	.dbline 104
; 		 if(value < 0)
	ldd R24,y+18
	ldd R25,y+19
	cpi R24,0
	ldi R30,0
	cpc R25,R30
	brlt X23
	xjmp L31
X23:
X14:
	.dbline 105
; 		 {	 
	.dbline 106
; 			text[count++] = MINUS;
	movw R2,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R24,R28
	movw R30,R2
	add R30,R24
	adc R31,R25
	ldi R24,239
	std z+0,R24
	.dbline 107
; 			value = -value;
	ldd R24,y+18
	ldd R25,y+19
	com R24
	com R25
	subi R24,0xFF
	sbci R25,0xFF
	std y+19,R25
	std y+18,R24
	.dbline 108
; 			start++;
	movw R24,R12
	adiw R24,1
	movw R12,R24
	.dbline 109
; 		 } 
	.dbline 110
; 	 }
	xjmp L31
L30:
	.dbline 111
; 	 else if (base == HEX)
	movw R24,R14
	cpi R24,16
	ldi R30,0
	cpc R25,R30
	brne L34
X15:
	.dbline 112
; 	 {
	.dbline 113
; 			text[count++] = DISPLAY_H;
	movw R2,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R24,R28
	movw R30,R2
	add R30,R24
	adc R31,R25
	ldi R24,73
	std z+0,R24
	.dbline 114
; 			start++;
	movw R24,R12
	adiw R24,1
	movw R12,R24
	.dbline 115
; 	 }
L34:
L31:
L36:
	.dbline 120
; 	 
; 
; 	 
; 	 //find the digits
; 	 do {
	.dbline 121
; 	 	if(count <= WIDTH)
	ldi R24,8
	ldi R25,0
	cp R24,R20
	cpc R25,R21
	brlt L38
X16:
	.dbline 122
; 		{
	.dbline 123
; 		 		 text[count++] = numbers[value % base];
	movw R10,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R18,R14
	ldd R16,y+18
	ldd R17,y+19
	xcall mod16s
	movw R30,R16
	ldi R24,<_numbers
	ldi R25,>_numbers
	add R30,R24
	adc R31,R25
	lpm R2,Z
	movw R24,R28
	movw R30,R10
	add R30,R24
	adc R31,R25
	std z+0,R2
	.dbline 124
; 		}
	.dbline 126
; 		else//Ensure our number is not to big to display
; 		{
	.dbline 127
; 		 break;
L40:
	.dbline 129
; 		}
; 	 } while ((value /= base) > 0);
L37:
	.dbline 129
	movw R18,R14
	ldd R16,y+18
	ldd R17,y+19
	xcall div16s
	movw R10,R16
	std y+19,R11
	std y+18,R10
	clr R2
	clr R3
	cp R2,R16
	cpc R3,R17
	brlt L36
X17:
L38:
	.dbline 131
; 	 
; 	 end = --count;
	movw R24,R20
	sbiw R24,1
	movw R10,R24
	movw R20,R24
	xjmp L42
L41:
	.dbline 136
; 
; 	 
; 	 //reverse to correct order
; 	 while (start <= count)
; 	 {
	.dbline 137
; 		 temp = text[start];
	movw R24,R28
	movw R30,R12
	add R30,R24
	adc R31,R25
	ldd R14,z+0
	.dbline 138
; 		 text[start] = text[count];
	movw R24,R28
	movw R30,R20
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	movw R24,R28
	movw R30,R12
	add R30,R24
	adc R31,R25
	std z+0,R2
	.dbline 139
; 		 text[count] = temp;
	movw R24,R28
	movw R30,R20
	add R30,R24
	adc R31,R25
	std z+0,R14
	.dbline 140
; 		 start++;
	movw R24,R12
	adiw R24,1
	movw R12,R24
	.dbline 141
; 		 count--; 
	subi R20,1
	sbci R21,0
	.dbline 142
; 	 }
L42:
	.dbline 135
	cp R20,R12
	cpc R21,R13
	brge L41
X18:
	.dbline 144
; 	  
;      if(end < WIDTH)
	movw R24,R10
	cpi R24,8
	ldi R30,0
	cpc R25,R30
	brlt X24
	xjmp L44
X24:
X19:
	.dbline 145
; 	 {
	.dbline 146
; 	  		for(count = WIDTH-1; count >= 0 ;count--)
	ldi R20,7
	ldi R21,0
L46:
	.dbline 147
; 			{
	.dbline 148
; 			 		if(end>=0)
	movw R24,R10
	cpi R24,0
	ldi R30,0
	cpc R25,R30
	brlt L50
X20:
	.dbline 149
; 					{
	.dbline 150
; 							display[line][count] = text[end--];
	movw R12,R24
	sbiw R24,1
	movw R10,R24
	ldi R24,<_display
	ldi R25,>_display
	movw R2,R22
	lsl R2
	rol R3
	lsl R2
	rol R3
	lsl R2
	rol R3
	add R2,R24
	adc R3,R25
	movw R30,R20
	add R30,R2
	adc R31,R3
	movw R24,R28
	movw R26,R12
	add R26,R24
	adc R27,R25
	ld R2,x
	std z+0,R2
	.dbline 151
; 					}
	xjmp L51
L50:
	.dbline 153
; 					else
; 					{
	.dbline 154
; 							display[line][count] = BLANK_SPACE;
	ldi R24,<_display
	ldi R25,>_display
	movw R2,R22
	lsl R2
	rol R3
	lsl R2
	rol R3
	lsl R2
	rol R3
	add R2,R24
	adc R3,R25
	movw R30,R20
	add R30,R2
	adc R31,R3
	ldi R24,255
	std z+0,R24
	.dbline 155
; 					}
L51:
	.dbline 156
; 			}
L47:
	.dbline 146
	subi R20,1
	sbci R21,0
	.dbline 146
	cpi R20,0
	ldi R30,0
	cpc R21,R30
	brlt X25
	xjmp L46
X25:
X21:
	.dbline 157
; 	 }
	xjmp L45
L44:
	.dbline 159
; 	 else//If our number was to large to display display --------
; 	 {
	.dbline 160
; 	  	 for(count=0; count < WIDTH;count++)
	clr R20
	clr R21
L52:
	.dbline 161
; 		 {
	.dbline 162
; 		  		  display[line][count] = MINUS;
	ldi R24,<_display
	ldi R25,>_display
	movw R2,R22
	lsl R2
	rol R3
	lsl R2
	rol R3
	lsl R2
	rol R3
	add R2,R24
	adc R3,R25
	movw R30,R20
	add R30,R2
	adc R31,R3
	ldi R24,239
	std z+0,R24
	.dbline 163
; 		 }
L53:
	.dbline 160
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 160
	cpi R20,8
	ldi R30,0
	cpc R21,R30
	brlt L52
X22:
	.dbline 164
; 	 }
L45:
	.dbline -2
L27:
	.dbline 0 ; func end
	adiw R28,8
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
	.dbsym r end 10 S
	.dbsym r temp 14 c
	.dbsym r start 12 S
	.dbsym l text 0 A[8:8]c
	.dbsym r count 20 S
	.dbsym r base 14 S
	.dbsym r line 22 S
	.dbsym l value 18 I
	.dbend
	.dbfunc e LED_Init _LED_Init fV
	.even
_LED_Init::
	.dbline -1
	.dbline 171
; }
; 
; /*
;  *Call this function to set your port directions
;  */
; void LED_Init(void)
; {
	.dbline 172
;  	 DDRB |= (~LED_B_CONTROL_MASK) | LED_B_DATA_MASK;
	in R24,0x4
	ori R24,63
	out 0x4,R24
	.dbline 173
;  	 DDRC |= LED_C_DATA_MASK;
	in R24,0x7
	ori R24,15
	out 0x7,R24
	.dbline 174
;  	 DDRD |= ~LED_D_CONTROL_MASK;
	in R24,0xa
	ori R24,252
	out 0xa,R24
	.dbline -2
L56:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e LED_Clear _LED_Clear fV
;              i -> R16,R17
;              j -> R18,R19
	.even
_LED_Clear::
	.dbline -1
	.dbline 179
; 
; }
; 
; void LED_Clear(void)
; {
	.dbline 182
;  	 short i, j;
; 	 
;  	 for(i = 0; i < LINES; i++)
	clr R16
	clr R17
L58:
	.dbline 183
;  	 {
	.dbline 184
;   	   for(j = 0; j < WIDTH; j++)
	clr R18
	clr R19
L62:
	.dbline 185
; 	   {
	.dbline 186
; 	   		 display[i][j] = BLANK_SPACE;
	ldi R24,<_display
	ldi R25,>_display
	movw R2,R16
	lsl R2
	rol R3
	lsl R2
	rol R3
	lsl R2
	rol R3
	add R2,R24
	adc R3,R25
	movw R30,R18
	add R30,R2
	adc R31,R3
	ldi R24,255
	std z+0,R24
	.dbline 187
; 	   }
L63:
	.dbline 184
	subi R18,255  ; offset = 1
	sbci R19,255
	.dbline 184
	cpi R18,8
	ldi R30,0
	cpc R19,R30
	brlt L62
X26:
	.dbline 188
;  	 }
L59:
	.dbline 182
	subi R16,255  ; offset = 1
	sbci R17,255
	.dbline 182
	cpi R16,1
	ldi R30,0
	cpc R17,R30
	brlt L58
X27:
	.dbline -2
L57:
	.dbline 0 ; func end
	ret
	.dbsym r i 16 S
	.dbsym r j 18 S
	.dbend
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\LED_Display.c
L67:
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\LED_Display.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\LED_Display.c
	.dbfunc e LED_Update _LED_Update fV
	.dbsym s digit L67 c
	.even
_LED_Update::
	.dbline -1
	.dbline 197
; }
; 
; /*
;  *Call this function to light one segment of the display
;  *The next time the function is called, the next segment
;  *will be lit
;  */
; void LED_Update(void)
; {
	.dbline 201
;  	 static unsigned char digit = 0;
; 	 
; 	 //Turn off the segments
; 	 PORTB |= LED_B_DATA_MASK;
	in R24,0x5
	ori R24,15
	out 0x5,R24
	.dbline 202
; 	 PORTC |= LED_C_DATA_MASK;
	in R24,0x8
	ori R24,15
	out 0x8,R24
	.dbline 205
; 	 
; 	 //Turn off the last Digit
; 	 PORTB &= LED_B_CONTROL_MASK;
	in R24,0x5
	andi R24,207
	out 0x5,R24
	.dbline 206
; 	 PORTD &= LED_D_CONTROL_MASK;
	in R24,0xb
	andi R24,3
	out 0xb,R24
	.dbline 209
; 	 
; 	 //Turn on the the new Digit
; 	 PORTB |= LED_B_CONTROL[digit];
	ldi R24,<_LED_B_CONTROL
	ldi R25,>_LED_B_CONTROL
	lds R30,L67
	clr R31
	add R30,R24
	adc R31,R25
	lpm R2,Z
	in R3,0x5
	or R3,R2
	out 0x5,R3
	.dbline 210
; 	 PORTD |= LED_D_CONTROL[digit];
	ldi R24,<_LED_D_CONTROL
	ldi R25,>_LED_D_CONTROL
	lds R30,L67
	clr R31
	add R30,R24
	adc R31,R25
	lpm R2,Z
	in R3,0xb
	or R3,R2
	out 0xb,R3
	.dbline 213
; 
; 	 //Turn on the current data
; 	 PORTC &= (display[0][digit]&0xF) | 0xF0;
	ldi R24,<_display
	ldi R25,>_display
	lds R30,L67
	clr R31
	add R30,R24
	adc R31,R25
	ldd R24,z+0
	andi R24,15
	ori R24,240
	in R2,0x8
	and R2,R24
	out 0x8,R2
	.dbline 215
; 	 //PORTB &= (numbers[digit]&0xF0)>>4;
; 	 PORTB &= ((display[0][digit]&0xF0)>>4) | 0xF0;
	ldi R24,<_display
	ldi R25,>_display
	lds R30,L67
	clr R31
	add R30,R24
	adc R31,R25
	ldd R24,z+0
	andi R24,240
	swap R24
	andi R24,#0x0F
	ori R24,240
	in R2,0x5
	and R2,R24
	out 0x5,R2
	.dbline 218
;  
; 	 //Update the next digit next time
; 	 digit++;
	lds R24,L67
	subi R24,255    ; addi 1
	sts L67,R24
	.dbline 220
; 	 
; 	 if(digit >= WIDTH)
	cpi R24,8
	brlo L68
X28:
	.dbline 221
; 	 {
	.dbline 222
; 	  	digit = 0;
	clr R2
	sts L67,R2
	.dbline 223
; 	 }
L68:
	.dbline -2
L66:
	.dbline 0 ; func end
	ret
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\LED_Display.c
_display::
	.blkb 8
	.dbsym e display _display A[8:1:8]c
	.area lit(rom, con, rel)
L7:
	.word 0xc5ac,0x3727
L6:
	.word 0x0,0x0
; }
