	.module Serial.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\Serial.c
	.dbfunc e uart0_init _uart0_init fV
	.even
_uart0_init::
	.dbline -1
	.dbline 7
; #include "Board.h"
; #include <iom168v.h>
; #include "Serial.h"
; 
; /* Initialize Serial Interface */
; void uart0_init (void)
; {
	.dbline 9
; //InitUART( 129 ); /* Set the baudrate 9600 no parity no stop?*/                   
; 	UBRR0 = 129;//51;                  /* Set the baud rate */
	ldi R24,129
	ldi R25,0
	sts 196+1,R25
	sts 196,R24
	.dbline 10
; 	UCSR0B = ( (1<<RXEN0) | (1<<TXEN0) );  /* Enable UART receiver and transmitter */
	ldi R24,24
	sts 193,R24
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e uart0_putc _uart0_putc fc
;             ch -> R16
	.even
_uart0_putc::
	.dbline -1
	.dbline 16
; 
; }
; 
; 
; unsigned char uart0_putc(unsigned char ch) 
; {
L3:
	.dbline 18
; 	while ( !(UCSR0A & (1<<UDRE0)) )
; 		; 			                /* Wait for empty transmit buffer */
L4:
	.dbline 17
	lds R2,192
	sbrs R2,5
	rjmp L3
X0:
	.dbline 19
; 	UDR0 = ch; 			        /* Start transmittion */
	sts 198,R16
	.dbline 21
; 	
; 	return ch;
	.dbline -2
L2:
	.dbline 0 ; func end
	ret
	.dbsym r ch 16 c
	.dbend
	.dbfunc e uart0_putchar _uart0_putchar fc
;             ch -> R20
	.even
_uart0_putchar::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 24
; }	
; 
; unsigned char uart0_putchar (unsigned char ch) {                      /* Write Character to Serial Port */
	.dbline 26
; 
;   if (ch == '\n')  {                            /* Check for LF */
	cpi R20,10
	brne L7
X1:
	.dbline 26
	.dbline 27
;     uart0_putc( '\r' );                         /* Output CR */
	ldi R16,13
	xcall _uart0_putc
	.dbline 28
;   }
L7:
	.dbline 29
;   return uart0_putc( ch );                     /* Transmit Character */
	mov R16,R20
	xcall _uart0_putc
	.dbline -2
L6:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r ch 20 c
	.dbend
	.dbfunc e uart0_puts _uart0_puts fV
;              s -> R10,R11
	.even
_uart0_puts::
	st -y,R10
	st -y,R11
	movw R10,R16
	.dbline -1
	.dbline 33
; }
; 
; void uart0_puts ( unsigned char* s )
; {
	xjmp L11
L10:
	.dbline 34
; 	while ( *s ) uart0_putchar( *s++ );
	movw R30,R10
	ld R16,Z+
	movw R10,R30
	xcall _uart0_putchar
L11:
	.dbline 34
	movw R30,R10
	ldd R2,z+0
	tst R2
	brne L10
X2:
	.dbline -2
L9:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
	.dbsym r s 10 pc
	.dbend
	.dbfunc e uart0_kbhit _uart0_kbhit fc
	.even
_uart0_kbhit::
	.dbline -1
	.dbline 38
; }
; 
; unsigned char uart0_kbhit( void ) /* returns true if character in receive buffer */
; {
	.dbline 43
; 	//if ( pUSART->US_CSR & AT91C_US_RXRDY) {
; 	//	return 1;
; 	//}
; 	//else {
; 		return 0;
	clr R16
	.dbline -2
L13:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e uart0_getc _uart0_getc fc
	.even
_uart0_getc::
	.dbline -1
	.dbline 48
; 	//}
; }
; 
; unsigned char uart0_getc ( void )  /* Read Character from Serial Port */
; {    
L15:
	.dbline 50
;   	while ( !(UCSR0A & (1<<RXC0)) ) 	/* Wait for incomming data */
; 		;			                /* Return the data */
L16:
	.dbline 49
	lds R2,192
	sbrs R2,7
	rjmp L15
X3:
	.dbline 51
; 	return UDR0;
	lds R16,198
	.dbline -2
L14:
	.dbline 0 ; func end
	ret
	.dbend
; }
