CC = iccavr
CFLAGS =  -e -D__ICC_VERSION="7.13A" -DATMEGA -D_EE_EXTIO -DATMega168  -l -g -Mavr_enhanced 
ASFLAGS = $(CFLAGS)  -Wa-g
LFLAGS =  -g -e:0x4000 -ucrtatmega.o -bfunc_lit:0x68.0x4000 -dram_end:0x4ff -bdata:0x100.0x4ff -dhwstk_size:32 -beeprom:0.512 -fihx_coff -S2
FILES = LED8_Controller.o LED8_Init.o LED8_ISRs.o LED8_SPI.o LED8_Uart.o LED8_Utilities.o TWI_slave.o 

LED8_CONTROLLER:	$(FILES)
	$(CC) -o LED8_CONTROLLER $(LFLAGS) @LED8_CONTROLLER.lk   -lfpatmega -lcatmega
LED8_Controller.o: C:\iccv7avr\include\iom168v.h C:\iccv7avr\include\macros.h C:\iccv7avr\include\string.h C:\iccv7avr\include\_const.h C:\iccv7avr\include\stdlib.h C:\iccv7avr\include\limits.h C:\iccv7avr\include\math.h C:\iccv7avr\include\stdio.h C:\iccv7avr\include\stdarg.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Uart.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Defines.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Extern.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\TWI_slave.h
LED8_Controller.o:	C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Controller.c
	$(CC) -c $(CFLAGS) C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Controller.c
LED8_Init.o: C:\iccv7avr\include\iom48v.h C:\iccv7avr\include\macros.h C:\iccv7avr\include\string.h C:\iccv7avr\include\_const.h C:\iccv7avr\include\stdlib.h C:\iccv7avr\include\limits.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Uart.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Defines.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Extern.h
LED8_Init.o:	C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Init.c
	$(CC) -c $(CFLAGS) C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Init.c
LED8_ISRs.o: C:\iccv7avr\include\iom48v.h C:\iccv7avr\include\macros.h C:\iccv7avr\include\string.h C:\iccv7avr\include\_const.h C:\iccv7avr\include\stdlib.h C:\iccv7avr\include\limits.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Uart.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Defines.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Extern.h
LED8_ISRs.o:	C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_ISRs.c
	$(CC) -c $(CFLAGS) C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_ISRs.c
LED8_SPI.o: C:\iccv7avr\include\iom48v.h C:\iccv7avr\include\macros.h C:\iccv7avr\include\string.h C:\iccv7avr\include\_const.h C:\iccv7avr\include\stdlib.h C:\iccv7avr\include\limits.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Uart.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Defines.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Extern.h
LED8_SPI.o:	C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_SPI.c
	$(CC) -c $(CFLAGS) C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_SPI.c
LED8_Uart.o: C:\iccv7avr\include\iom48v.h C:\iccv7avr\include\macros.h C:\iccv7avr\include\string.h C:\iccv7avr\include\_const.h C:\iccv7avr\include\stdlib.h C:\iccv7avr\include\limits.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Uart.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Defines.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Extern.h
LED8_Uart.o:	C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Uart.c
	$(CC) -c $(CFLAGS) C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Uart.c
LED8_Utilities.o: C:\iccv7avr\include\iom48v.h C:\iccv7avr\include\macros.h C:\iccv7avr\include\string.h C:\iccv7avr\include\_const.h C:\iccv7avr\include\stdlib.h C:\iccv7avr\include\limits.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Uart.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Defines.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Extern.h
LED8_Utilities.o:	C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Utilities.c
	$(CC) -c $(CFLAGS) C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Utilities.c
TWI_slave.o: C:\iccv7avr\include\iom168v.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\TWI_slave.h
TWI_slave.o:	C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\TWI_slave.c
	$(CC) -c $(CFLAGS) C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\TWI_slave.c
